Aria: ArRetFunctor3C< Ret, T, P1, P2, P3 > Class Template Reference

- Main Page
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# ArRetFunctor3C< Ret, T, P1, P2, P3 > Class Template Reference

`#include <ArFunctor.h>`

Inheritance diagram for ArRetFunctor3C< Ret, T, P1, P2, P3 >:

List of all members.

## Detailed Description

### template<class Ret, class T, class P1, class P2, class P3>
class ArRetFunctor3C< Ret, T, P1, P2, P3 >

Functor for a member function with return value and 3 parameters.

This is a class for member functions which take 3 parameters and return a value. This class contains the knowledge on how to call a member function on a particular instance of a class. This class should be instantiated by code that wishes to pass off a functor to another piece of code.

For an overall description of functors, see ArFunctor.

## Public Member Functions
| ArRetFunctor3C (T *obj, Ret(T::*func)(P1, P2, P3), P1 p1, P2 p2, P3 p3)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T *obj, Ret(T::*func)(P1, P2, P3), P1 p1, P2 p2)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T *obj, Ret(T::*func)(P1, P2, P3), P1 p1)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T *obj, Ret(T::*func)(P1, P2, P3))
| Constructor - supply function pointer.
| ArRetFunctor3C (T &obj, Ret(T::*func)(P1, P2, P3), P1 p1, P2 p2, P3 p3)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T &obj, Ret(T::*func)(P1, P2, P3), P1 p1, P2 p2)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T &obj, Ret(T::*func)(P1, P2, P3), P1 p1)
| Constructor - supply function pointer, default parameters.
| ArRetFunctor3C (T &obj, Ret(T::*func)(P1, P2, P3))
| Constructor - supply function pointer.
| ArRetFunctor3C ()
| Constructor.
virtual Ret | invokeR (P1 p1, P2 p2, P3 p3)
| Invokes the functor with return value.
virtual Ret | invokeR (P1 p1, P2 p2)
| Invokes the functor with return value.
virtual Ret | invokeR (P1 p1)
| Invokes the functor with return value.
virtual Ret | invokeR (void)
| Invokes the functor with return value.
virtual void | setP1 (P1 p1)
| Set the default parameter.
virtual void | setP2 (P2 p2)
| Set the default 2nd parameter.
virtual void | setP3 (P3 p3)
| Set the default third parameter.
virtual void | setThis (T &obj)
| Set the 'this' pointer.
virtual void | setThis (T *obj)
| Set the 'this' pointer.
virtual | ~ArRetFunctor3C ()
| Destructor.
## Protected Attributes
Ret(T::* | myFunc )(P1, P2, P3)
T * | myObj
P1 | myP1
P2 | myP2
P3 | myP3

## Constructor & Destructor Documentation

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T & | obj,
|  | Ret(T::*)(P1, P2, P3) | func |
| ) |  |  | `[inline]`

Constructor - supply function pointer.

Parameters:

  | obj | object to call function on
  | func | member function pointer

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T & | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T & | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1,
|  | P2 | p2 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter
  | p2 | default second parameter

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T & | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1,
|  | P2 | p2,
|  | P3 | p3 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter
  | p2 | default second parameter
  | p3 | default third parameter

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T * | obj,
|  | Ret(T::*)(P1, P2, P3) | func |
| ) |  |  | `[inline]`

Constructor - supply function pointer.

Parameters:

  | obj | object to call function on
  | func | member function pointer

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T * | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T * | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1,
|  | P2 | p2 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter
  | p2 | default second parameter

template<class Ret, class T, class P1, class P2, class P3>

ArRetFunctor3C< Ret, T, P1, P2, P3 >::ArRetFunctor3C | ( | T * | obj,
|  | Ret(T::*)(P1, P2, P3) | func,
|  | P1 | p1,
|  | P2 | p2,
|  | P3 | p3 |
| ) |  |  | `[inline]`

Constructor - supply function pointer, default parameters.

Parameters:

  | obj | object to call function on
  | func | member function pointer
  | p1 | default first parameter
  | p2 | default second parameter
  | p3 | default third parameter

## Member Function Documentation

template<class Ret, class T, class P1, class P2, class P3>

virtual Ret ArRetFunctor3C< Ret, T, P1, P2, P3 >::invokeR | ( | P1 | p1,
|  | P2 | p2,
|  | P3 | p3 |
| ) |  |  | `[inline, virtual]`

Invokes the functor with return value.

Parameters:

  | p1 | first parameter
  | p2 | second parameter
  | p3 | third parameter

Implements ArRetFunctor3< Ret, P1, P2, P3 >.

template<class Ret, class T, class P1, class P2, class P3>

virtual Ret ArRetFunctor3C< Ret, T, P1, P2, P3 >::invokeR | ( | P1 | p1,
|  | P2 | p2 |
| ) |  |  | `[inline, virtual]`

Invokes the functor with return value.

Parameters:

  | p1 | first parameter
  | p2 | second parameter

Implements ArRetFunctor3< Ret, P1, P2, P3 >.

template<class Ret, class T, class P1, class P2, class P3>

virtual Ret ArRetFunctor3C< Ret, T, P1, P2, P3 >::invokeR | ( | P1 | p1 | ) | `[inline, virtual]`

Invokes the functor with return value.

Parameters:

  | p1 | first parameter

Implements ArRetFunctor3< Ret, P1, P2, P3 >.

template<class Ret, class T, class P1, class P2, class P3>

virtual void ArRetFunctor3C< Ret, T, P1, P2, P3 >::setP1 | ( | P1 | p1 | ) | `[inline, virtual]`

Set the default parameter.

Parameters:

  | p1 | default first parameter

template<class Ret, class T, class P1, class P2, class P3>

virtual void ArRetFunctor3C< Ret, T, P1, P2, P3 >::setP2 | ( | P2 | p2 | ) | `[inline, virtual]`

Set the default 2nd parameter.

Parameters:

  | p2 | default second parameter

template<class Ret, class T, class P1, class P2, class P3>

virtual void ArRetFunctor3C< Ret, T, P1, P2, P3 >::setP3 | ( | P3 | p3 | ) | `[inline, virtual]`

Set the default third parameter.

Parameters:

  | p3 | default third parameter

template<class Ret, class T, class P1, class P2, class P3>

virtual void ArRetFunctor3C< Ret, T, P1, P2, P3 >::setThis | ( | T & | obj | ) | `[inline, virtual]`

Set the 'this' pointer.

Parameters:

  | obj | object to call function on
  | obj | the 'this' pointer

template<class Ret, class T, class P1, class P2, class P3>

virtual void ArRetFunctor3C< Ret, T, P1, P2, P3 >::setThis | ( | T * | obj | ) | `[inline, virtual]`

Set the 'this' pointer.

Parameters:

  | obj | object to call function on
  | obj | the 'this' pointer

The documentation for this class was generated from the following file:

- ArFunctor.h